Gecode::Int::NValues::Graph Class Reference

View-value graph for propagation of upper bound. More...

`#include <nvalues.hh>`

## Public Member Functions

| Graph (void)
| Construct graph as not yet initialized.
int | size (void) const
| Return size of maximal matching (excluding assigned views).
void | init (Space &home, const ValSet &vs, const ViewArray< IntView > &x)
| Initialize graph including values in vs.
void | sync (void)
| Synchronize graph with new view domains.
bool | mark (void)
ExecStatus | prune (Space &home)
| Prune all values corresponding to unused edges.
Public Member Functions inherited from Gecode::Int::ViewValGraph::Graph< IntView >
| Graph (void)
| Construct graph as not yet initialized.
| operator bool (void) const
| Test whether graph has been initialized.
void | purge (void)
| Purge graph if necessary (reset information to avoid overflow).

## Protected Attributes

int | n_matched
| Number of matched edges.
Protected Attributes inherited from Gecode::Int::ViewValGraph::Graph< IntView >
ViewNode< IntView > ** | view
| Array of view nodes.
ValNode< IntView > * | val
| Array of value nodes.
int | n_view
| Number of view nodes.
int | n_val
| Number of value nodes.
unsigned int | count
| Marking counter.

## Additional Inherited Members

Protected Types inherited from Gecode::Int::ViewValGraph::Graph< IntView >
typedef Support::StaticStack< ViewNode< IntView > *, Region > | ViewNodeStack
| Stack used during matching.
Protected Member Functions inherited from Gecode::Int::ViewValGraph::Graph< IntView >
void | init (Space &home, ViewNode< IntView > *x)
| Initialize the edges for the view node x.
bool | match (ViewNodeStack &m, ViewNode< IntView > *x)
| Find a matching for node x.
void | scc (void)
| Compute the strongly connected components.

## Detailed Description

View-value graph for propagation of upper bound.

Definition at line 96 of file nvalues.hh.

## Constructor & Destructor Documentation

## Graph()

Graph::Graph | ( | void |  | ) |

inline

Construct graph as not yet initialized.

Definition at line 37 of file graph.hpp.

## Member Function Documentation

## size()

int Graph::size | ( | void |  | ) | const

inline

Return size of maximal matching (excluding assigned views).

Definition at line 41 of file graph.hpp.

## init()

void Graph::init | ( | Space & | home,
|  | const ValSet & | vs,
|  | const ViewArray< IntView > & | x )

inline

Initialize graph including values in vs.

Definition at line 46 of file graph.hpp.

## sync()

void Graph::sync | ( | void |  | ) |

inline

Synchronize graph with new view domains.

Definition at line 90 of file graph.hpp.

## mark()

bool Graph::mark | ( | void |  | ) |

inline

Definition at line 152 of file graph.hpp.

## prune()

ExecStatus Graph::prune | ( | Space & | home | ) |

inline

Prune all values corresponding to unused edges.

Definition at line 255 of file graph.hpp.

## Member Data Documentation

## n_matched

int Gecode::Int::NValues::Graph::n_matched

protected

Number of matched edges.

Definition at line 99 of file nvalues.hh.

The documentation for this class was generated from the following files:

- gecode/int/nvalues.hh
- gecode/int/nvalues/graph.hpp